//+------------------------------------------------------------------+
//|                           Indicator: 60 Directional 1 and 5M.mq4 |
//|                                       Created with EABuilder.com |
//|                                             http://eabuilder.com |
//+------------------------------------------------------------------+
#property copyright "Created with EABuilder.com"
#property link      "http://eabuilder.com"
#property version   "1.00"
#property description ""

#include <stdlib.mqh>
#include <stderror.mqh>

//--- indicator settings
#property indicator_chart_window
#property indicator_buffers 2

#property indicator_type1 DRAW_LINE
#property indicator_style1 STYLE_SOLID
#property indicator_width1 2
#property indicator_color1 0x5E00FF
#property indicator_label1 "Sell"

#property indicator_type2 DRAW_LINE
#property indicator_style2 STYLE_SOLID
#property indicator_width2 2
#property indicator_color2 0xFF9100
#property indicator_label2 "Buy"

//--- indicator buffers
double Buffer1[];
double Buffer2[];

datetime time_alert; //used when sending alert
extern bool Send_Email = true;
extern bool Audible_Alerts = true;
extern bool Push_Notifications = true;
double myPoint; //initialized in OnInit

void myAlert(string type, string message)
  {
   int handle;
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | 60 Directional 1 and 5M @ "+Symbol()+","+Period()+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
   else if(type == "indicator")
     {
      Print(type+" | 60 Directional 1 and 5M @ "+Symbol()+","+Period()+" | "+message);
      if(Audible_Alerts) Alert(type+" | 60 Directional 1 and 5M @ "+Symbol()+","+Period()+" | "+message);
      if(Send_Email) SendMail("60 Directional 1 and 5M", type+" | 60 Directional 1 and 5M @ "+Symbol()+","+Period()+" | "+message);
      handle = FileOpen("60 Directional 1 and 5M.txt", FILE_TXT|FILE_READ|FILE_WRITE|FILE_SHARE_READ|FILE_SHARE_WRITE, ';');
      if(handle != INVALID_HANDLE)
        {
         FileSeek(handle, 0, SEEK_END);
         FileWrite(handle, type+" | 60 Directional 1 and 5M @ "+Symbol()+","+Period()+" | "+message);
         FileClose(handle);
        }
      if(Push_Notifications) SendNotification(type+" | 60 Directional 1 and 5M @ "+Symbol()+","+Period()+" | "+message);
     }
  }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   IndicatorBuffers(2);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, 0);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, 0);
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
     }
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   //--- initial zero
   if(prev_calculated < 1)
     {
      ArrayInitialize(Buffer1, 0);
      ArrayInitialize(Buffer2, 0);
     }
   else
      limit++;
   
   //--- main loop
   for(int i = limit-1; i >= 0; i--)
     {
      if (i >= MathMin(20000-1, rates_total-1-500)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      //Indicator Buffer 1
      if(iMA(NULL, PERIOD_CURRENT, 61, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 60, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 60, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 59, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 59, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 58, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 305, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 300, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 300, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 295, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 295, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 290, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      )
        {
         Buffer1[i] = iMA(NULL, PERIOD_CURRENT, 60, 0, MODE_LWMA, PRICE_CLOSE, i); //Set indicator value at Moving Average
         if(i == 0 && Time[0] != time_alert) { myAlert("indicator", "Sell"); time_alert = Time[0]; } //Instant alert, only once per bar
        }
      else
        {
         Buffer1[i] = 0;
        }
      //Indicator Buffer 2
      if(iMA(NULL, PERIOD_CURRENT, 61, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 60, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 60, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 59, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 59, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 58, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 305, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 300, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 300, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 295, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 295, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 290, 0, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      )
        {
         Buffer2[i] = iMA(NULL, PERIOD_CURRENT, 60, 0, MODE_LWMA, PRICE_CLOSE, i); //Set indicator value at Moving Average
         if(i == 0 && Time[0] != time_alert) { myAlert("indicator", "Buy"); time_alert = Time[0]; } //Instant alert, only once per bar
        }
      else
        {
         Buffer2[i] = 0;
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+