//+------------------------------------------------------------------+
//|                                     Indicator: MADirectionV2.mq4 |
//|                                       Created with EABuilder.com |
//|                                             http://eabuilder.com |
//+------------------------------------------------------------------+
#property copyright "Created with EABuilder.com"
#property link      "http://eabuilder.com"
#property version   "1.00"
#property description ""

#include <stdlib.mqh>
#include <stderror.mqh>

//--- indicator settings
#property indicator_chart_window
#property indicator_buffers 2

#property indicator_type1 DRAW_ARROW
#property indicator_width1 1
#property indicator_color1 0xFFAA00
#property indicator_label1 "Buy"

#property indicator_type2 DRAW_ARROW
#property indicator_width2 1
#property indicator_color2 0x5500FF
#property indicator_label2 "Sell"

//--- indicator buffers
double Buffer1[];
double Buffer2[];

double myPoint; //initialized in OnInit

void myAlert(string type, string message)
  {
   if(type == "print")
      Print(message);
   else if(type == "error")
     {
      Print(type+" | MADirectionV2 @ "+Symbol()+","+Period()+" | "+message);
     }
   else if(type == "order")
     {
     }
   else if(type == "modify")
     {
     }
  }

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {   
   IndicatorBuffers(2);
   SetIndexBuffer(0, Buffer1);
   SetIndexEmptyValue(0, 0);
   SetIndexArrow(0, 233);
   SetIndexBuffer(1, Buffer2);
   SetIndexEmptyValue(1, 0);
   SetIndexArrow(1, 234);
   //initialize myPoint
   myPoint = Point();
   if(Digits() == 5 || Digits() == 3)
     {
      myPoint *= 10;
     }
   return(INIT_SUCCEEDED);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime& time[],
                const double& open[],
                const double& high[],
                const double& low[],
                const double& close[],
                const long& tick_volume[],
                const long& volume[],
                const int& spread[])
  {
   int limit = rates_total - prev_calculated;
   //--- counting from 0 to rates_total
   ArraySetAsSeries(Buffer1, true);
   ArraySetAsSeries(Buffer2, true);
   //--- initial zero
   if(prev_calculated < 1)
     {
      ArrayInitialize(Buffer1, 0);
      ArrayInitialize(Buffer2, 0);
     }
   else
      limit++;
   
   //--- main loop
   for(int i = limit-1; i >= 0; i--)
     {
      if (i >= MathMin(5000-1, rates_total-1-50)) continue; //omit some old rates to prevent "Array out of range" or slow calculation   
      //Indicator Buffer 1
      if(iMA(NULL, PERIOD_CURRENT, 5, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 5, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 8, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 8, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 25, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 25, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 40, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 40, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 75, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 75, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 120, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 120, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 150, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 150, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 240, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 240, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 300, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 300, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      && iMA(NULL, PERIOD_CURRENT, 480, 0, MODE_LWMA, PRICE_CLOSE, i) < iMA(NULL, PERIOD_CURRENT, 480, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average < Moving Average
      )
        {
         Buffer1[i] = Close[1+i]; //Set indicator value at Candlestick Close
        }
      else
        {
         Buffer1[i] = 0;
        }
      //Indicator Buffer 2
      if(iMA(NULL, PERIOD_CURRENT, 5, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 5, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 8, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 8, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 25, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 25, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 40, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 40, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 75, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 75, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 120, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 120, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 150, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 150, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 240, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 240, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 300, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 300, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      && iMA(NULL, PERIOD_CURRENT, 480, 0, MODE_LWMA, PRICE_CLOSE, i) > iMA(NULL, PERIOD_CURRENT, 480, -1, MODE_LWMA, PRICE_CLOSE, i) //Moving Average > Moving Average
      )
        {
         Buffer2[i] = Close[1+i]; //Set indicator value at Candlestick Close
        }
      else
        {
         Buffer2[i] = 0;
        }
     }
   return(rates_total);
  }
//+------------------------------------------------------------------+